# Ogre::RenderQueue Class Reference

Class to manage the scene object rendering queue. More...

`#include <OgreRenderQueue.h>`

List of all members.

## Public Types

typedef std::map< RenderQueueGroupID, RenderQueueGroup * > | RenderQueueGroupMap
typedef MapIterator< RenderQueueGroupMap > | QueueGroupIterator
| Iterator over queue groups.

## Public Member Functions

| RenderQueue ()
virtual | ~RenderQueue ()
void | clear (bool destroyPassMaps=false)
| Empty the queue - should only be called by SceneManagers.
RenderQueueGroup * | getQueueGroup (RenderQueueGroupID qid)
| Get a render queue group.
void | addRenderable (Renderable *pRend, RenderQueueGroupID groupID, ushort priority)
| Add a renderable object to the queue.
void | addRenderable (Renderable *pRend, RenderQueueGroupID groupId)
| Add a renderable object to the queue.
void | addRenderable (Renderable *pRend)
| Add a renderable object to the queue.
RenderQueueGroupID | getDefaultQueueGroup (void) const
| Gets the current default queue group, which will be used for all renderable which do not specify which group they wish to be on.
void | setDefaultRenderablePriority (ushort priority)
| Sets the current default renderable priority, which will be used for all renderables which do not specify which priority they wish to use.
ushort | getDefaultRenderablePriority (void) const
| Gets the current default renderable priority, which will be used for all renderables which do not specify which priority they wish to use.
void | setDefaultQueueGroup (RenderQueueGroupID grp)
| Sets the current default queue group, which will be used for all renderable which do not specify which group they wish to be on.
QueueGroupIterator | _getQueueGroupIterator (void)
| Internal method, returns an iterator for the queue groups.
void | setSplitPassesByLightingType (bool split)
| Sets whether or not the queue will split passes by their lighting type, ie ambient, per-light and decal.
void | setSplitNoShadowPasses (bool split)
| Sets whether or not the queue will split passes which have shadow receive turned off (in their parent material), which is needed when certain shadow techniques are used.

## Protected Attributes

RenderQueueGroupMap | mGroups
RenderQueueGroupID | mDefaultQueueGroup
| The current default queue group.
ushort | mDefaultRenderablePriority
| The default priority.
bool | mSplitPassesByLightingType
bool | mSplitNoShadowPasses

## Detailed Description

Class to manage the scene object rendering queue.

Remarks:
  Objects are grouped by material to minimise rendering state changes. The map from material to renderable object is wrapped in a class for ease of use.

  This class now includes the concept of 'queue groups' which allows the application adding the renderable to specifically schedule it so that it is included in a discrete group. Good for separating renderables into the main scene, backgrounds and overlays, and also could be used in the future for more complex multipass routines like stenciling.

Definition at line 73 of file OgreRenderQueue.h.

## Member Typedef Documentation

typedef MapIterator<RenderQueueGroupMap> Ogre::RenderQueue::QueueGroupIterator

| Iterator over queue groups. Definition at line 78 of file OgreRenderQueue.h.

typedef std::map< RenderQueueGroupID, RenderQueueGroup* > Ogre::RenderQueue::RenderQueueGroupMap

| Definition at line 76 of file OgreRenderQueue.h.

## Constructor & Destructor Documentation

Ogre::RenderQueue::RenderQueue | ( |  | ) |

virtual Ogre::RenderQueue::~RenderQueue | ( |  | ) | `[virtual]`

## Member Function Documentation

QueueGroupIterator Ogre::RenderQueue::_getQueueGroupIterator | ( | void |  | ) |

| Internal method, returns an iterator for the queue groups.

void Ogre::RenderQueue::addRenderable | ( | Renderable * | pRend | ) |

Add a renderable object to the queue.

Remarks:
  This methods adds a Renderable to the queue, which will be rendered later by the SceneManager. This is the simplified version of the call which does not require a queue or priority to be specified. The queue group is taken from the current default (see setDefaultQueueGroup). The queue priority is take from the current default (see setDefaultRenderablePriority).

Note:
  Called by implementation of MovableObject::_updateRenderQueue.

Parameters:

  pRend | Pointer to the Renderable to be added to the queue

void Ogre::RenderQueue::addRenderable | ( | Renderable * | pRend,
|  | RenderQueueGroupID | groupId
| ) |

Add a renderable object to the queue.

Remarks:
  This methods adds a Renderable to the queue, which will be rendered later by the SceneManager. This is the simplified version of the call which does not require a priority to be specified. The queue priority is take from the current default (see setDefaultRenderablePriority).

Note:
  Called by implementation of MovableObject::_updateRenderQueue.

Parameters:

  pRend | Pointer to the Renderable to be added to the queue
  groupID | The group the renderable is to be added to. This can be used to schedule renderable objects in separate groups such that the SceneManager respects the divisions between the groupings and does not reorder them outside these boundaries. This can be handy for overlays where no matter what you want the overlay to be rendered last.

void Ogre::RenderQueue::addRenderable | ( | Renderable * | pRend,
|  | RenderQueueGroupID | groupID,
|  | ushort | priority
| ) |

Add a renderable object to the queue.

Remarks:
  This methods adds a Renderable to the queue, which will be rendered later by the SceneManager. This is the advanced version of the call which allows the renderable to be added to any queue.

Note:
  Called by implementation of MovableObject::_updateRenderQueue.

Parameters:

  pRend | Pointer to the Renderable to be added to the queue
  groupID | The group the renderable is to be added to. This can be used to schedule renderable objects in separate groups such that the SceneManager respects the divisions between the groupings and does not reorder them outside these boundaries. This can be handy for overlays where no matter what you want the overlay to be rendered last.
  priority | Controls the priority of the renderable within the queue group. If this number is raised, the renderable will be rendered later in the group compared to it's peers. Don't use this unless you really need to, manually ordering renderables prevents OGRE from sorting them for best efficiency. However this could be useful for ordering 2D elements manually for example.

void Ogre::RenderQueue::clear | ( | bool | destroyPassMaps = false | ) |

Empty the queue - should only be called by SceneManagers.

Parameters:

  destroyPassMaps | Set to true to destroy all pass maps so that the queue is completely clean (useful when switching scene managers)

RenderQueueGroupID Ogre::RenderQueue::getDefaultQueueGroup | ( | void |  | ) | const

| Gets the current default queue group, which will be used for all renderable which do not specify which group they wish to be on.

ushort Ogre::RenderQueue::getDefaultRenderablePriority | ( | void |  | ) | const

| Gets the current default renderable priority, which will be used for all renderables which do not specify which priority they wish to use.

RenderQueueGroup* Ogre::RenderQueue::getQueueGroup | ( | RenderQueueGroupID | qid | ) |

Get a render queue group.

Remarks:
  OGRE registers new queue groups as they are requested, therefore this method will always return a valid group.

void Ogre::RenderQueue::setDefaultQueueGroup | ( | RenderQueueGroupID | grp | ) |

| Sets the current default queue group, which will be used for all renderable which do not specify which group they wish to be on.

void Ogre::RenderQueue::setDefaultRenderablePriority | ( | ushort | priority | ) |

| Sets the current default renderable priority, which will be used for all renderables which do not specify which priority they wish to use.

void Ogre::RenderQueue::setSplitNoShadowPasses | ( | bool | split | ) |

| Sets whether or not the queue will split passes which have shadow receive turned off (in their parent material), which is needed when certain shadow techniques are used.

void Ogre::RenderQueue::setSplitPassesByLightingType | ( | bool | split | ) |

| Sets whether or not the queue will split passes by their lighting type, ie ambient, per-light and decal.

## Member Data Documentation

RenderQueueGroupID Ogre::RenderQueue::mDefaultQueueGroup `[protected]`

| The current default queue group. Definition at line 82 of file OgreRenderQueue.h.

ushort Ogre::RenderQueue::mDefaultRenderablePriority `[protected]`

| The default priority. Definition at line 84 of file OgreRenderQueue.h.

RenderQueueGroupMap Ogre::RenderQueue::mGroups `[protected]`

| Definition at line 80 of file OgreRenderQueue.h.

bool Ogre::RenderQueue::mSplitNoShadowPasses `[protected]`

| Definition at line 87 of file OgreRenderQueue.h.

bool Ogre::RenderQueue::mSplitPassesByLightingType `[protected]`

| Definition at line 86 of file OgreRenderQueue.h.

The documentation for this class was generated from the following file:

- OgreRenderQueue.h

Copyright © 2000-2005 by The OGRE Team
Last modified Sun Nov 20 12:38:37 2005